package edu.ubu.csapp;

import java.io.*;
import java.util.*;

public class DataStreamApp {

  static Product[] products = {
      new Product("Shirt", 250.00, 10),
      new Product("Jeans", 1550.00, 15),
      new Product("Mug", 150.00, 20),
      new Product("Jacket", 5499.00, 5),
      new Product("Computer", 26490.00, 8)
  };

  static void save(String fileName) {
      try (DataOutputStream out = new DataOutputStream(
                  new BufferedOutputStream(
                    new FileOutputStream(fileName)
                  )
                 )
          ) {
          for (Product p : products) {
              out.writeUTF(p.getDescription());
              out.writeDouble(p.getPrice());
              out.writeInt(p.getUnit());
          }

      } catch (IOException ex) {
        ex.printStackTrace();
      }
  }

  static ArrayList<Product> load(String fileName) {
      ArrayList<Product> productList = new ArrayList<Product>();
      try (DataInputStream input = new DataInputStream(
                    new BufferedInputStream(
                      new FileInputStream(fileName)
                    )
                  )
              ) {
          while (true) {
              Product p = new Product();
              p.setDescription(input.readUTF());
              p.setPrice(input.readDouble());
              p.setUnit(input.readInt());
              System.out.println(p);
              productList.add(p);
          }
      } catch (EOFException e) {
        e.printStackTrace();
      } catch (IOException e) {
        e.printStackTrace();
      }
    return productList;
  }

  public static void main(String[] args) throws IOException {
    save(args[1]);
    ArrayList<Product> productList = load(args[1]);
  }
}