package edu.ubu.csapp;

import java.io.*;

public class ObjectStreamApp {

  static Product[] products = {
      new Product("Shirt", 250.00, 10),
      new Product("Jeans", 1550.00, 15),
      new Product("Mug", 150.00, 20),
      new Product("Jacket", 5499.00, 5),
      new Product("Computer", 26490.00, 8)
  };

  static void saveObject(String fileName) {
      try (ObjectOutputStream out = new ObjectOutputStream(
                  new BufferedOutputStream(
                    new FileOutputStream(fileName)
                  )
                 )
          ) {
          out.writeObject(products);
      } catch (IOException ex) {
        ex.printStackTrace();
      }
  }

  static Product[] loadObject(String fileName) {
      Product[] products = null;
      try (ObjectInputStream input = new ObjectInputStream(
                    new BufferedInputStream(
                      new FileInputStream(fileName)
                    )
               )
             ) {
          products = (Product[])(input.readObject());
      } catch (ClassNotFoundException e) {
        e.printStackTrace();
      } catch (EOFException e) {
        e.printStackTrace();
      } catch (IOException e) {
        e.printStackTrace();
      }
    return products;
  }

  public static void main(String[] args) throws IOException {
    saveObject(args[1]);
    Product[] products = loadObject(args[1]);
  }

}